#!/bin/sh

# $Id: whizard-config.in 2022 2010-03-07 20:36:24Z cnspeckn $
#
# Configure libtool for the current host.
#
########################################################################
#
# Copyright (C) 1999-2015 by 
#     Wolfgang Kilian <kilian@physik.uni-siegen.de>
#     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
#     Juergen Reuter <juergen.reuter@desy.de>
#     Christian Speckner <cnspeckn@googlemail.com>
#
# WHIZARD is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# WHIZARD is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
########################################################################

usage() {
cat <<EOI
usage: libtool-config [options]

Configures a site-specific libtool version.

Available options:
   --prefix DIR    : directory containing the WHIZARD installation
EOI
exit
}

while test -n "$1"; do
   case "$1" in
      "--prefix")
	 if test -n "$2"; then
	     shift
	     prefix=$1
         else
             usage
         fi
         ;;
      "--help")
         usage
         ;;
      *)
         usage
   esac
   shift
done

if test -z "$prefix"; then
  prefix=/opt/whizard/whizard-2.2.8
fi

## Configure the libtool 'package' in a temporary workspace .libtool-config
## and copy the result (the libtool script) to the current working dir.
wd=`pwd`
if test -d $prefix/share/libtool-config; then
    if test -d .libtool-config; then
	rm -rf .libtool-config
    fi
    mkdir .libtool-config
    touch .libtool-config/Makefile.in
    cd .libtool-config && sh $prefix/share/libtool-config/configure
    cd $wd
    if test -f .libtool-config/libtool; then
	cp .libtool-config/libtool .
	echo "libtool-config.sh: Libtool configuration successful"
	rm -rf .libtool-config
    else
	echo "libtool-config.sh: Libtool configuration failed"
	exit 1
    fi
else
    echo "libtool-config.sh: couldn't find data dir $prefix/share/libtool-config"
    exit 1
fi

